/*
 * GccApplication1.c
 *
 * Created: 11.03.2020 19:06:49
 * Author : grace
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>

void TIMER1_setup(void);
void TIMER3_setup(void);
void ADC_setup(void);
void USART0_setup(void);

int current=0;
int w_power=0;
int voltage=0;
int abc = 0;

uint8_t     rx_buf[100];
uint16_t    rx_ptr;
uint8_t     tx_char;

int main(void)
{
	
	DDRE |= 0x10;				/* PE4 = output */
	TIMER1_setup();
	TIMER3_setup();
	ADC_setup();
	USART0_setup();
	
	sei();

    /* Replace with your application code */
    while (1) 
    {
		
		
    }
}

void TIMER1_setup(void)
{
	TCCR1A = 0x00; //No output (Tab. 17-3) 
	TCCR1B = 0x15; //Clock enabled, prescaler 64
	TCCR1C = 0x00;

	ICR1 = 30000;
	TCNT1 = 0x00;
	TIMSK1 = 0x01;
}

void TIMER3_setup(void) 
{
	TCCR3A = 0x20; // output PWM 2
	TCCR3B = 0x11; // clock enabled
	TCCR3C = 0x00;

	ICR3 = 800;
	OCR3B = 0;
	TCNT3 = 0x00;
}

void ADC_setup(void)
{
	ADMUX = 0xC0; // Vref=2.56V  Canal=ADC0
	ADCSRA = 0xAE; // ADC enabled; Trigger start enabled; EOC interupt enabled
	ADCSRB = 0x06;
}

void USART0_setup(void) 
{

	rx_ptr = 0;
	tx_char = 'A';

	UBRR0 = 103;    /* 9k6 @ 16 MHz */
	UCSR0A = 0x00;
	UCSR0B = 0x1B;
	UCSR0C = 0x06;

}

ISR(TIMER1_OVF_vect) //Necessary, absence sets PWM T3 B to log.1
{
	
}

ISR(ADC_vect)
{
	
	if (ADMUX&0x01)
	{
		voltage = ADC*5;	// Ubat [mV]
		ADMUX=0xC0;			// Switch to AD 0
	}
	else
	{
		current = ADC*5;	// Ibat [mA]
		ADMUX=0xC1;			// Switch to AD 1
	}
	
	
	if (UCSR0A&0x80)
	{
		w_power=UDR0;
		UCSR0A=UCSR0A&(~0x80);
	}

	OCR3B=w_power*3.2;
	
	/*
	int abc = 5000;
	while (!(UCSR0A & (1 << UDRE0)));
	UDR0 = abc;
	abc >>=8;
	while (!(UCSR0A & (1 << UDRE0)));
	UDR0 = abc;
	*/
	
	if (w_power>0)
	{
		
	abc=voltage;
	
	abc >>= 8;

	while (!(UCSR0A & (1 << UDRE0)));
	UDR0 = abc;

	
	
	while (!(UCSR0A & (1 << UDRE0)));
	UDR0 = voltage;
	
	}

}

